package cn.com.qmth.examcloud.core.basic.service.impl;

import java.util.Date;

import javax.transaction.Transactional;

import cn.com.qmth.examcloud.core.basic.dao.StudentFaceInfoRepo;
import cn.com.qmth.examcloud.core.basic.dao.StudentRepo;
import cn.com.qmth.examcloud.core.basic.dao.entity.StudentEntity;
import cn.com.qmth.examcloud.core.basic.dao.entity.StudentFaceEntity;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class StudentFaceInfoService {

	@Autowired
	StudentFaceInfoRepo studentFaceInfoRepo;

	@Autowired
	StudentRepo studentRepo;

	/**
	 * 判断faceSet是否可用 faceSet在ecs_core_student_face_info表中的记录数不允许超过8000
	 * 
	 * @param faceSet
	 * @return
	 */
	public boolean judgeFaceSetIsAvailable(String faceSet) {
		if (StringUtils.isBlank(faceSet)) {
			return false;
		}
		Long size = studentFaceInfoRepo.countByFaceSetToken(faceSet);
		return size <= 8000 ? true : false;
	}

}
